<?php
/**
 * Plugin Name: PayStar Payment Module For Whmcs 5-6
 * Plugin URI: https://paystar.ir
 * Version: 1.0
 * Author: Shayan Kiyani
 * Author Email: info[at]paystar[dot]ir
 */

if (!defined("WHMCS")) die("This file cannot be accessed directly");

function paystar_config() 
{
	require(dirname(__FILE__) . '/../../paystarconfig.php');
	return array(
		"FriendlyName" => array(
			"Type" => "System",
			"Value" => $ws_config['name']
		),
		"pin" => array(
			"FriendlyName" => "شناسه درگاه",
			"Type" => "text",
			"Size" => "50",
			"Value" => "",
			"Description" => "طراح و برنامه نویس : <a href=\"https://paystar.ir\" target=\"_blank\">شایان کیانی</a>",
        ),
		"shayancr" => array(
			"FriendlyName" => "واحد پولی", 
			"Type" => 'dropdown', 
			"Options" => "Rial,Toman", 
		),
        /*"shayanbank" => array(
			"FriendlyName" => "بانک", 
			"Type" => "dropdown", 
			"Options" => implode(',', array_keys($ws_config['bank'])),		
			"Description" => "بانک مورد نظر برای انجام تراکنش ها", 
		)*/
    );
}

function paystar_link($params) 
{
	require(dirname(__FILE__) . '/../../paystarconfig.php');
	$err = false;
	$amount = strtok($params['amount'], '.');
	if(isset($_POST['shayanbank']))
	{
		$amount2 = ($params['shayancr']=='Toman') ? intval($amount) : intval($amount/10);
		$callback = $params['systemurl'] . '/modules/gateways/callback/paystar.php?invoiceid=' . $params['invoiceid'] . '&amount=' . $params['amount'] . '&amount2=' . $amount2;	
		try 
		{
			if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
				$ip = $_SERVER['HTTP_CLIENT_IP'];
			} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
				$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
			} else {
				$ip = $_SERVER['REMOTE_ADDR'];
			}
			$f = array(
				'amount' => $amount2,
				'pin' => $params['pin'],
				'callback' => $callback,
				'bank' => $_POST['shayanbank'],
				'ip' => $ip,
				'description' => "نام و نام خانوادگی : {$params['clientdetails']['firstname']} {$params['clientdetails']['lastname']}
شماره موبایل : {$params['clientdetails']['phonenumber']}
ایمیل :‌ {$params['clientdetails']['email']}
توضیحات کاربر : {$params['description']}"
			);

			$f_ = '';
			foreach($f as $k=>$v) 
				$f_ .= $k . '=' . urlencode($v) . '&'; 
				
			rtrim($f_, '&');

			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL, "https://{$ws_config['address']}/api/create/");
			curl_setopt($ch,CURLOPT_POST, count($f));
			curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
			$res = curl_exec($ch);
			curl_close($ch);
			if (!$res) 
				$err = 'اتصال به بانک برقرار نشد .';
			else 
			{
				if(strlen($res) > 5)
				{
					header("Location: https://{$ws_config['address']}/paying/{$res}");
					exit;
				}	
				else
					$err = $res;				
			}
		}
		catch (Exception $e) 
		{
			$err = 'اتصال به بانک برقرار نشد .';
		} 		
	}

	$form = '' . PHP_EOL;
	if(!empty($err))
		$form .= '<p><font color="red">' . $err . '</font></p>';	
	else if(!empty($_GET['res_err']))
	{
		$res_err = base64_decode($_GET['res_err']);
		if($res_err == -90)
			$res_err = 'تراکنش پرداخت نشده است .';
		
		$form .= '<p><font color="red">' . $res_err . '</font></p>';	
	}
				
	$form .= '<form name="paystar" action="' . $params['systemurl'] . '/viewinvoice.php?id=' . $params['invoiceid'] . '" method="POST">';
	$form .= '<select name="shayanbank">';
	foreach($ws_config['bank'] as $k=>$v)
		$form .= "<option value='{$k}'>{$v}</option>\n";
	$form .= '</select>';
	$form .= '<input class="submit" type="submit" value=" پرداخت " />';
	$form .= '</form>'; 
	return $form; 	
}